#ifndef G__WINFUNC_H
#define G__WINFUNC_H

#ifdef __MAKECINT__

// Win32 VXeT[rXvO~O WindowsNT/95VXeAPI reference
// Prentice - Toppan , ISBN4-88735-030-9

/***********************************************************************
* Types
***********************************************************************/
#pragma link C class _COMMTIMEOUTS;
#pragma link C typedef COMMTIMEOUTS;
#pragma link C typedef LPCOMMTIMEOUTS;

#pragma link C class _DCB;
#pragma link C typedef DCB;
#pragma link C typedef LPDCB;

#pragma link C class _OVERLAPPED;
#pragma link C typedef OVERLAPPED;
#pragma link C typedef LPOVERLAPPED;

#pragma link C typedef LPCHOOSECOLOR;

#pragma link C typedef LPCHOOSEFONT;

#pragma link C typedef LPPAGESETUPDLG;

#pragma link C typedef LPPRINTDLG;

#pragma link C typedef LPFINDREPLACE;

#pragma link C typedef LPOVERLAPPED_COMPLETION_ROUTINE;

#pragma link C typedef BOOL;
#pragma link C typedef DWORD;
#pragma link C typedef DWORD;
#pragma link C typedef HANDLE;
#pragma link C typedef HINSTANCE;
#pragma link C typedef LPCVOID;
#pragma link C typedef UINT;


/***********************************************************************
* Constants
***********************************************************************/
#define GENERIC_READ                (0x80000000) /* from WINNT.H */
#define GENERIC_WRITE               (0x40000000) /* from WINNT.H */
#define FILE_SHARE_READ             (0x00000001) /* from WINNT.H */
#define FILE_SHARE_WRITE            (0x00000002) /* from WINNT.H */
#define FILE_FLAG_SEQUENTIAL_SCAN   0x08000000
#define CREATE_NEW          1
#define CREATE_ALWAYS       2
#define OPEN_EXISTING       3
#define OPEN_ALWAYS         4
#define TRUNCATE_EXISTING   5

#ifndef _MAC
#define INVALID_HANDLE_VALUE        ((HANDLE)(-1))
#define DELETE                      0x00010000L

#define FILE_BEGIN                  0
#define FILE_CURRENT                1
#define FILE_END                    2
#endif

#define FILE_ATTRIBUTE_READONLY         0x00000001
#define FILE_ATTRIBUTE_HIDDEN           0x00000002
#define FILE_ATTRIBUTE_SYSTEM           0x00000004
#define FILE_ATTRIBUTE_DIRECTORY        0x00000010
#define FILE_ATTRIBUTE_ARCHIVE          0x00000020
#define FILE_ATTRIBUTE_NORMAL           0x00000080
#define FILE_ATTRIBUTE_TEMPORARY        0x00000100

#define FILE_FLAG_WRITE_THROUGH     0x80000000
#define FILE_FLAG_RANDOM_ACCESS     0x10000000

#define TIME_ZONE_ID_INVALID        0xFFFFFFFF
#define TIME_ZONE_ID_UNKNOWN        0
#define TIME_ZONE_ID_STANDARD       1
#define TIME_ZONE_ID_DAYLIGHT       2

#define INVALID_HANDLE_VALUE (HANDLE)-1
#define INVALID_FILE_SIZE (DWORD)0xFFFFFFFF

#define FILE_BEGIN           0
#define FILE_CURRENT         1
#define FILE_END             2

#define TIME_ZONE_ID_INVALID (DWORD)0xFFFFFFFF

#define WAIT_FAILED (DWORD)0xFFFFFFFF

#define DRIVE_UNKNOWN     0
#define DRIVE_NO_ROOT_DIR 1
#define DRIVE_REMOVABLE   2
#define DRIVE_FIXED       3
#define DRIVE_REMOTE      4
#define DRIVE_CDROM       5
#define DRIVE_RAMDISK     6


#define GetFreeSpace(w)                 (0x100000L)


#define FILE_TYPE_UNKNOWN   0x0000
#define FILE_TYPE_DISK      0x0001
#define FILE_TYPE_CHAR      0x0002
#define FILE_TYPE_PIPE      0x0003
#define FILE_TYPE_REMOTE    0x8000


#define STD_INPUT_HANDLE    (DWORD)-10
#define STD_OUTPUT_HANDLE   (DWORD)-11
#define STD_ERROR_HANDLE      (DWORD)-12

#define NOPARITY            0
#define ODDPARITY           1
#define EVENPARITY          2
#define MARKPARITY          3
#define SPACEPARITY         4

#define ONESTOPBIT          0
#define ONE5STOPBITS        1
#define TWOSTOPBITS         2

#define IGNORE              0       // Ignore signal
#define INFINITE            0xFFFFFFFF  // Infinite timeout

//
// Basud rates at which the communication device operates
//

#define CBR_110             110
#define CBR_300             300
#define CBR_600             600
#define CBR_1200            1200
#define CBR_2400            2400
#define CBR_4800            4800
#define CBR_9600            9600
#define CBR_14400           14400
#define CBR_19200           19200
#define CBR_38400           38400
#define CBR_56000           56000
#define CBR_57600           57600
#define CBR_115200          115200
#define CBR_128000          128000
#define CBR_256000          256000

//
// Error Flags
//

#define CE_RXOVER           0x0001  // Receive Queue overflow
#define CE_OVERRUN          0x0002  // Receive Overrun Error
#define CE_RXPARITY         0x0004  // Receive Parity Error
#define CE_FRAME            0x0008  // Receive Framing error
#define CE_BREAK            0x0010  // Break Detected
#define CE_TXFULL           0x0100  // TX Queue is full
#define CE_PTO              0x0200  // LPTx Timeout
#define CE_IOE              0x0400  // LPTx I/O Error
#define CE_DNS              0x0800  // LPTx Device not selected
#define CE_OOP              0x1000  // LPTx Out-Of-Paper
#define CE_MODE             0x8000  // Requested mode unsupported

#define IE_BADID            (-1)    // Invalid or unsupported id
#define IE_OPEN             (-2)    // Device Already Open
#define IE_NOPEN            (-3)    // Device Not Open
#define IE_MEMORY           (-4)    // Unable to allocate queues
#define IE_DEFAULT          (-5)    // Error in default parameters
#define IE_HARDWARE         (-10)   // Hardware Not Present
#define IE_BYTESIZE         (-11)   // Illegal Byte Size
#define IE_BAUDRATE         (-12)   // Unsupported BaudRate

//
// Events
//

#define EV_RXCHAR           0x0001  // Any Character received
#define EV_RXFLAG           0x0002  // Received certain character
#define EV_TXEMPTY          0x0004  // Transmitt Queue Empty
#define EV_CTS              0x0008  // CTS changed state
#define EV_DSR              0x0010  // DSR changed state
#define EV_RLSD             0x0020  // RLSD changed state
#define EV_BREAK            0x0040  // BREAK received
#define EV_ERR              0x0080  // Line status error occurred
#define EV_RING             0x0100  // Ring signal detected
#define EV_PERR             0x0200  // Printer error occured
#define EV_RX80FULL         0x0400  // Receive buffer is 80 percent full
#define EV_EVENT1           0x0800  // Provider specific event 1
#define EV_EVENT2           0x1000  // Provider specific event 2

//
// Escape Functions
//

#define SETXOFF             1       // Simulate XOFF received
#define SETXON              2       // Simulate XON received
#define SETRTS              3       // Set RTS high
#define CLRRTS              4       // Set RTS low
#define SETDTR              5       // Set DTR high
#define CLRDTR              6       // Set DTR low
#define RESETDEV            7       // Reset device if possible
#define SETBREAK            8       // Set the device break line.
#define CLRBREAK            9       // Clear the device break line.

//
// PURGE function flags.
//
#define PURGE_TXABORT       0x0001  // Kill the pending/current writes to the comm port.
#define PURGE_RXABORT       0x0002  // Kill the pending/current reads to the comm port.
#define PURGE_TXCLEAR       0x0004  // Kill the transmit queue if there.
#define PURGE_RXCLEAR       0x0008  // Kill the typeahead buffer if there.

#define LPTx                0x80    // Set if ID is for LPT device

//
// Modem Status Flags
//
#define MS_CTS_ON           ((DWORD)0x0010)
#define MS_DSR_ON           ((DWORD)0x0020)
#define MS_RING_ON          ((DWORD)0x0040)
#define MS_RLSD_ON          ((DWORD)0x0080)

//
// WaitSoundState() Constants
//

#define S_QUEUEEMPTY        0
#define S_THRESHOLD         1
#define S_ALLTHRESHOLD      2

//
// Accent Modes
//

#define S_NORMAL      0
#define S_LEGATO      1
#define S_STACCATO    2

//
// SetSoundNoise() Sources
//

#define S_PERIOD512   0     // Freq = N/512 high pitch, less coarse hiss
#define S_PERIOD1024  1     // Freq = N/1024
#define S_PERIOD2048  2     // Freq = N/2048 low pitch, more coarse hiss
#define S_PERIODVOICE 3     // Source is frequency from voice channel (3)
#define S_WHITE512    4     // Freq = N/512 high pitch, less coarse hiss
#define S_WHITE1024   5     // Freq = N/1024
#define S_WHITE2048   6     // Freq = N/2048 low pitch, more coarse hiss
#define S_WHITEVOICE  7     // Source is frequency from voice channel (3)

#define S_SERDVNA     (-1)  // Device not available
#define S_SEROFM      (-2)  // Out of memory
#define S_SERMACT     (-3)  // Music active
#define S_SERQFUL     (-4)  // Queue full
#define S_SERBDNT     (-5)  // Invalid note
#define S_SERDLN      (-6)  // Invalid note length
#define S_SERDCC      (-7)  // Invalid note count
#define S_SERDTP      (-8)  // Invalid tempo
#define S_SERDVL      (-9)  // Invalid volume
#define S_SERDMD      (-10) // Invalid mode
#define S_SERDSH      (-11) // Invalid shape
#define S_SERDPT      (-12) // Invalid pitch
#define S_SERDFQ      (-13) // Invalid frequency
#define S_SERDDR      (-14) // Invalid duration
#define S_SERDSR      (-15) // Invalid source
#define S_SERDST      (-16) // Invalid state

#define NMPWAIT_WAIT_FOREVER            0xffffffff
#define NMPWAIT_NOWAIT                  0x00000001
#define NMPWAIT_USE_DEFAULT_WAIT        0x00000000

/* Flags returned by LocalFlags (in addition to LMEM_DISCARDABLE) */
#define LMEM_DISCARDED      0x4000
#define LMEM_LOCKCOUNT      0x00FF

//
// dwCreationFlag values
//

#define DEBUG_PROCESS               0x00000001
#define DEBUG_ONLY_THIS_PROCESS     0x00000002

#define CREATE_SUSPENDED            0x00000004

#define DETACHED_PROCESS            0x00000008

#define CREATE_NEW_CONSOLE          0x00000010

#define NORMAL_PRIORITY_CLASS       0x00000020
#define IDLE_PRIORITY_CLASS         0x00000040
#define HIGH_PRIORITY_CLASS         0x00000080
#define REALTIME_PRIORITY_CLASS     0x00000100

#define CREATE_NEW_PROCESS_GROUP    0x00000200
#define CREATE_UNICODE_ENVIRONMENT  0x00000400

#define CREATE_SEPARATE_WOW_VDM     0x00000800
#define CREATE_SHARED_WOW_VDM       0x00001000

#define CREATE_DEFAULT_ERROR_MODE   0x04000000
#define CREATE_NO_WINDOW            0x08000000

#define PROFILE_USER                0x10000000
#define PROFILE_KERNEL              0x20000000
#define PROFILE_SERVER              0x40000000

/***********************************************************************
***********************************************************************
* API FUNCTIONS
***********************************************************************
***********************************************************************/

/***********************************************************************
* DLL 
***********************************************************************/
HINSTANCE LoadLibrary(LPCSTR lpszLibFileName);
#pragma link C func LoadLibrary;

void FreeLibrary(HINSTANCE hinst);
#pragma link C func FreeLibrary;

FARPROC GetProcAddress(HINSTANCE hinst,LPCSTR lpszProcName);
#pragma link C func GetProcAddress;

/* int GetModuleUsage(HINSTANCE hinst); */
/* #pragma link C func GetModuleUsage */

/***********************************************************************
* File
***********************************************************************/
BOOL CopyFile(LPCTSTR lpExistingFileName,LPCTSTR lpNewFileName
	      ,BOOL bFailIfExists);
#pragma link C func CopyFile;

DWORD GetCurrentDirectory(DWORD nBufferLength,LPTSTR lpBuffer);
#pragma link C func GetCurrentDirectory;

BOOL GetDiskFreeSpace(LPCTSTR lpRootPathName,LPDWORD lpSectorsPerCluster
		      ,LPDWORD lpByteperSector,LPDWORD lpNumberOfFreeClusters
		      ,LPDWORD lpTotalNumberOfClusters);
#pragma link C func GetDiskFreeSpace;

DWORD GetFileAttributes(LPCTSTR lpFileName);
#pragma link C func GetFileAttributes;

DWORD GetFileSize(HANDLE hFile,LPDWORD lpFleSizeHigh);
#pragma link C func GetFileSize;

DWORD GetFileType(HANDLE hFile);
#pragma link C func GetFileType;

DWORD GetFullPathName(LPCTSTR lpFileName,DWORD nBufferLength,LPTSTR lpBuffer
		      ,LPTSTR *lpFilePart);
#pragma link C func GetFullPathName;

BOOL LockFile(HANDLE hFile,DWORD dwFileOffsetLow,DWORD dwFileOffsetHigh
	      ,DWORD nNumberofBytesToLockLow,DWORD nNumberOfBytesTOLockHigh);
#pragma link C func LockFile;

BOOL MoveFile(LPCTSTR lpExistingFileName,LPCTSTR lpNewFileName);
#pragma link C func MoveFile;

BOOL ReadFile(HANDLE hFile,LPVOID lpBuffer,DWORD nNumberOfBytesToRead
	      ,LPDWORD lpNumberOfBytesRead,LPOVERLAPPED lpOverlapped);
#pragma link C func ReadFile;

BOOL RemoveDirectory(LPCTSTR lpPathName);
#pragma link C func RemoveDirectory;

BOOL WriteFile(HANDLE hFile,LPCVOID lpBuffer,DWORD nNumberOfBytesToWrite,LPDWORD lpNumberOfBytesWritten,LPOVERLAPPED lpOverlapped);
#pragma link C func WriteFile;

/***********************************************************************
* COMM port
***********************************************************************/
HANDLE CreateFile(LPCTSTR lpFileName,DWORD dwDesiredAccess,DWORD dwShareMode,LPSECURITY_ATTRIBUTES lpSecurityAttributes,DWORD dwCreationDisposition,DWORD dwFlagsAndAttributes,HANDLE hTemplateFile);
#pragma link C func CreateFile;

BOOL GetCommState(HANDLE hFile,LPDCB lpDCB);
#pragma link C func GetCommState;

BOOL SetCommState(HANDLE hFile,LPDCB lpDCB);
#pragma link C func SetCommState;

BOOL SetCommTimeouts(HANDLE hFile,LPCOMMTIMEOUTS lpCommTimeouts);
#pragma link C func SetCommTimeouts;

BOOL GetCommTimeouts(HANDLE hFile,LPCOMMTIMEOUTS lpCommTimeouts);
#pragma link C func GetCommTimeouts;

BOOL EscapeCommFunction(HANDLE hFile,DWORD dwFunc);
#pragma link C func EscapeCommFunction;

BOOL CloseHandle(HANDLE hObject);
#pragma link C func CloseHandle;

BOOL SetCommMask(HANDLE hFile,DWORD dwEvtMask);
#pragma link C func SetCommMask;

BOOL WaitCommEvent(HANDLE hFile,LPDWORD lpEvMask,LPOVERLAPPED lpOverlapped);
#pragma link C func WaitCommEvent;

/***********************************************************************
* Event
***********************************************************************/
DWORD WaitForSingleObject(HANDLE hHandle,DWORD dwMilliseconds);
#pragma link C func WaitForSingleObject;

DWORD WaitForMultipleObjects(DWORD nCOunt,const HANDLE* lpHandles,BOOL bWaitAll,DWORD dwMilliseconds);
#pragma link C func WaitForMultipleObjects;

BOOL PulseEvent(HANDLE hEvent);
#pragma link C func PulseEvent;

BOOL ResetEvent(HANDLE hEvent);
#pragma link C func ResetEvent;

BOOL CreateEvent(LPSECURITY_ATTRIBUTES lpEventAttributes,BOOL bManualReset,BOOL bIniitialState,LPCTSTR lpName);
#pragma link C func CreateEvent;

/***********************************************************************
* Window
***********************************************************************/
BOOL AdjustWindowRect(LPRECT lprc,DWORD dwStyle,BOOL fMenu);
#pragma link C func AdjustWindowRect;

HWND CreateWindow(LPCTSTR lpszClassName,LPCTSTR lpszWindowName
		  ,DWORD dwStyle,int x,int y,int nWidth,int nHeight
		  ,HWND hwndParent,HMENU hmenu,HANDLE hinst,LPVOID lpvParam);
#pragma link C func CreateWindow;

BOOL DestroyWindow(HWND hwnd);
#pragma link C func DestroyWindow;

BOOL GetWindow(HWND hWnd,UINT uCmd);
#pragma link C func GetWindow;

int GetWindowText(HWND hWnd,LPTSTR lpString,int nMaxCount);
#pragma link C func GetWindowText;

BOOL MoveWindow(HWND hWnd,int X,int Y,int nWidth,int nHeight,BOOL bRepaing);
#pragma link C func MoveWindow;

BOOL SetWindowText(HWND hWnd,LPCTSTR lpString);
#pragma link C func SetWindowText;


/***********************************************************************
* Caret
***********************************************************************/
void CreateCaret(HWND hwnd,HBITMAP hbmp,int nWidth,int nHeight);
#pragma link C func CreateCaret;

BOOL GetCaretPos(LPPOINT lpPoint);
#pragma link C func GetCaretPos;

BOOL HideCaret(HWND hWnd);
#pragma link C func HideCaret;

/***********************************************************************
* Clipboard
***********************************************************************/
BOOL CloseClipboard();
#pragma link C func CloseClipboard;

BOOL EmptyClipboard();
#pragma link C func EmptyClipboard;

HANDLE GetClipboardData(UINT uFormat);
#pragma link C func GetClipboardData;

BOOL OpenClipboard(HWND hWndNewOwner);
#pragma link C func OpenClipboard;

/***********************************************************************
* Common Dialog Box
***********************************************************************/
BOOL ChooseColor(LPCHOOSECOLOR lpcc);
#pragma link C func ChooseColor;

BOOL ChooseFont(LPCHOOSEFONT lpcf);
#pragma link C func ChooseFont;

HWND FindText(LPFINDREPLACE lpfr);
#pragma link C func FindText;

short GetFileTitle(LPCTSTR lpszFile,LPTSTR lpszTitle,WORD cbBuf);
#pragma link C func GetFileTitle;

BOOL GetOpenFileName(LPOPENFILENAME lpofn);
#pragma link C func GetOpenFileName;

BOOL GetSaveFileName(LPOPENFILENAME lpofn);
#pragma link C func GetSaveFileName;

BOOL PageSetupDlg(LPPAGESETUPDLG lppsd);
#pragma link C func PageSetupDlg;

BOOL PrintDlg(LPPRINTDLG lppd);
#pragma link C func PrintDlg;

HWND ReplaceText(LPFINDREPLACE lpfr);
#pragma link C func ReplaceText;

/***********************************************************************
* Timer
***********************************************************************/
void Sleep(DWORD dwMilliseconds);
#pragma link C func Sleep;


/***********************************************************************
* Error
***********************************************************************/
BOOL Beep(DWORD dwFreq,DWORD dwDuration);
#pragma link C func Beep;

BOOL ExitWindows(DWORD dwReserved,UINT uReserved);
#pragma link C func ExitWindows;

DWORD GetLastError();
#pragma link C func GetLastError;

void ExitProcess(UINT uExitCode);
#pragma link C func ExitProcess;


/**********************************************************************/
#endif // __MAKECINT__

#endif // G__WINFUNC_H


